<template>
  <div class="d-flex flex-col">

    <router-link tag="button" class="icon-button text-secondary"
      to="/welcome#login"
      style="position: absolute; left: 6px; top: 8px; height: 30px;">
      <v-icon name="arrow-left"/>
    </router-link>

    <h2 class="mh-5 mt-1 mb-0"><i>FORGOT PASSWORD</i></h2>

    <Error v-if="error" :error.sync="error" round class="mv-2"/>
    <p v-else>{{ msg }}</p>

    <form v-if="canSendReset && !tok">
      <div class="input-group mh-1">
        <span>Email</span>
        <input type="email" v-model="email">
      </div>

      <AsyncButton class="primary mh-auto mt-2 mb-5" :fn="onSubmit">
        Reset password
      </AsyncButton>
    </form>

    <form v-else-if="tok">
      <div class="input-group mh-1">
        <span>New password</span>
        <input type="password" v-model="newPassword">
      </div>

      <div class="input-group mh-1">
        <span>Confirm password</span>
        <input type="password" v-model="confirmPassword">
      </div>

      <AsyncButton class="primary mh-auto mt-2 mb-5" :fn="onReset">
        Reset password
      </AsyncButton>
    </form>

    <Policy by="clicking Reset password"/>
  </div>
</template>

<script>
import Policy from '@/components/Policy.vue';
import axios from 'axios';

export default {
  data: () => ({
    msg: 'Tell us your email and we\'ll send you a reset link',
    error: null,
    email: null,
    canSendReset: true,
    tok: null,

    newPassword: null,
    confirmPassword: null,
  }),
  components: {
    Policy,
  },
  watch: {
    $route() {
      this.handleUrlChange();
    },
  },
  methods: {
    async onSubmit(e) {
      e.preventDefault();
      if (!this.email || /^\s+$/.test(this.email))
        return ;
      this.error = null;
      try {
        await axios.post('/api/auth/reset_request', { email: this.email });
        this.msg = 'If this email is valid you should have received a reset'
                   + ' link, please check your inbox';
        this.canSendReset = false;
      }
      catch(err) {
        if (err.response)
          this.error = err.response.data.error;
      }
    },
    async onReset(e) {
      e.preventDefault();
      if (!this.newPassword || !this.confirmPassword)
        return ;
      if (this.newPassword !== this.confirmPassword)
        return this.error = 'Passwords don\'t match';
      if (/^\s+$/.test(this.newPassword))
        return this.error = 'Password can\' be empty';
      this.error = null;
      try {
        const payload = { tok: this.tok, password: this.newPassword };
        let { data } = await axios.post(`/api/auth/reset_password`, payload);

        this.msg = 'Password reset successfully!';
        this.$store.commit('setUser', data.user);
        this.$store.commit('setToken', data.token);
        this.$router.push('/');
      }
      catch(err) {
        if (err.response)
          this.error = err.response.data.error;
      }
    },
    handleUrlChange() {
      if (this.$route.hash === '#forgotpass' && this.$route.query.tok) {
        this.tok = this.$route.query.tok;
      }
    },
  },
  mounted() {
    this.handleUrlChange();
  },
};
</script>

<style scoped>
</style>
